#include <bits/stdc++.h>

using namespace std;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int tt;
    cin >> tt;
    while (tt--) {
        int n, m;
        cin >> n >> m;
        vector<vector<int>> grev(n);
        vector<int> deg(n);
        for (int i = 0; i < m; i++) {
            int a, b;
            cin >> a >> b;
            a--; b--;
            deg[a]--;
            grev[b].push_back(a);
        }
        set<pair<int, int>> st;
        for (int i = 0; i < n; i++) {
            st.insert({deg[i], i});
        }
        vector<int> ans;
        while (!st.empty()) {
            auto [x, v] = *st.begin();
            st.erase(st.begin());
            ans.push_back(v + 1);
            for (auto el : grev[v]) {
                pair<int, int> p = {deg[el], el};
                auto it = st.find(p);
                if (it != st.end()) {
                    st.erase(st.find(p));
                    deg[el]++;
                    st.insert({deg[el], el});
                }
            }
        }
        for (auto el : ans) {
            cout << el << " ";
        }
        cout << "\n";
    }
}
