#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

#define all(vc) vc.begin(), vc.end()
#define full(vc) vc.begin(), vc.end()

#define fi first
#define fr first
#define se second
#define sc second

#define pb push_back

typedef vector<int> vi;
typedef vector<ll> vl;

const ll INF = 1e18;

template <typename T>
istream& operator>>(istream& in, vector<T> &vc)
{
    for (auto &el: vc) in >> el;
    return in;
}

void dfs2(int v, vector <int> &used, vector <vector<pii>> &vc, set <int> &mp)
{
    used[v] = 1;
    for (auto [u, i]: vc[v])
    {
        if (used[u] == 1)
        {
            mp.insert(i);
        }
        if (!used[u])
        {
            dfs2(u, used, vc, mp);
        }
    }
    used[v] = 2;
}

void dfs(int v, vector <int> &used, vector <vector<pii>> &vc, vector <int> &tp, set <int> &mp)
{
    used[v] = 1;
    for (auto [u, i]: vc[v])
    {
        if (mp.count(i))
        {
            continue;
        }
        if (!used[u])
        {
            dfs(u, used, vc, tp, mp);
        }
    }
    tp.pb(v);
}

void solve()
{
    int n, m;
    cin >> n >> m;

    vector <int> used(n);
    set <int> mp;
    vector <vector<pii>> vc(n);
    vector <int> tp;

    for (int i = 0; i < m; i++)
    {
        int a, b;
        cin >> a >> b;
        a--; b--;
        vc[a].pb({b, i});
    }

    for (int i = 0; i < n; i++)
    {
        if (!used[i])
        {
            dfs2(i, used, vc, mp);
        }
    }
    /*cout << "LOL\n";
    for (auto i : mp)
    {
        cout << i << endl;
    }
    cout << endl;*/
    used.clear();
    used.resize(n);
    for (int i = 0; i < n; i++)
    {
        if (!used[i])
        {
            dfs(i, used, vc, tp, mp);
        }
    }
    reverse(all(tp));

    vector <int> arr(n);
    int cnt = 0;
    for (int i = 0; i < n; i++)
    {
        arr[tp[i]] = i;
    }
    for (auto el : tp)
    {
        for (auto [u, i]: vc[el])
        {
            if (arr[el] < arr[u])
            {
                cnt++;
            }
        }
    }
    if (cnt >= m / 2 + m % 2)
    {
        for (auto i: tp) cout << i + 1 << ' ';
    }
    else
    {
        cout << n / 0;
    }
}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int t = 1;
    cin >> t;
    while (t--)
    {
        solve();
        cout << '\n';
    }
    return 0;
}
