#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>

using namespace std;

#define int long long

const int MOD = 998'244'353;

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n;
        vector<int> a(n);
        vector<int> b(n);
        for (int i = 0; i < n; i++) cin >> a[i];
        for (int i = 0; i < n; i++) cin >> b[i];

        vector<int> build1(n), build3(n), move(n), setup1(n), setup3(n), ans(n);
        build1[0] = abs(a[0] - 1);
        build3[0] = abs(a[0] - 3);
        move[0] = 2;
        setup1[0] = abs(b[0] - 1);
        setup3[0] = abs(b[0] - 3);
        ans[0] = abs(a[0] - b[0]);
        for (int i = 1; i < n; i++) {
            move[i] = (3 * move[i - 1] + 2) % MOD;

            if (a[i] == 1) {
                build1[i] = build1[i - 1];
                build3[i] = (build3[i - 1] + 2 * move[i - 1] + 2) % MOD;
            } else if (a[i] == 2) {
                build1[i] = (build3[i - 1] + move[i - 1] + 1) % MOD;
                build3[i] = (build1[i - 1] + move[i - 1] + 1) % MOD;
            } else if (a[i] == 3) {
                build1[i] = (build1[i - 1] + 2 * move[i - 1] + 2) % MOD;
                build3[i] = build3[i - 1];
            }

            if (b[i] == 1) {
                setup1[i] = setup1[i - 1];
                setup3[i] = (2 * move[i - 1] + 2 + setup3[i - 1]) % MOD;
            } else if (b[i] == 2) {
                setup1[i] = (move[i - 1] + 1 + setup3[i - 1]) % MOD;
                setup3[i] = (move[i - 1] + 1 + setup1[i - 1]) % MOD;
            } else if (b[i] == 3) {
                setup1[i] = (2 * move[i - 1] + 2 + setup1[i - 1]) % MOD;
                setup3[i] = setup3[i - 1];
            }

            if (a[i] == b[i])
                ans[i] = ans[i - 1];
            else if (a[i] == 1 && b[i] == 2)
                ans[i] = (build3[i - 1] + 1 + setup3[i - 1]) % MOD;
            else if (a[i] == 1 && b[i] == 3)
                ans[i] = (build3[i - 1] + 2 + move[i - 1] + setup1[i - 1]) % MOD;
            else if (a[i] == 2 && b[i] == 1)
                ans[i] = (build3[i - 1] + 1 + setup3[i - 1]) % MOD;
            else if (a[i] == 2 && b[i] == 3)
                ans[i] = (build1[i - 1] + 1 + setup1[i - 1]) % MOD;
            else if (a[i] == 3 && b[i] == 1)
                ans[i] = (build1[i - 1] + 2 + move[i - 1] + setup3[i - 1]) % MOD;
            else if (a[i] == 3 && b[i] == 2)
                ans[i] = (build1[i - 1] + 1 + setup1[i - 1]) % MOD;
        }

        cout << ans[n - 1] << endl;
    }
}