#include<bits/stdc++.h>

// #define int long long
// #define f(i, n) for(int i = 0; i < (int)n; i++)
// #define F(i, a, b) for(int i = (int)a; i <= (int)b; i++)
#define ll long long
#define pii pair<int, int>
#define vii vector<pii>
#define ld long double
#define vi vector<int>
#define vll vector<ll>
#define all(x) x.begin(), x.end()
const int maxN = 2e5 + 5;
const int inf = 2e9;
const ld pi = acosl(-1);
const ld eps = 1e-5;
const int mod = 998244353;

using namespace std;
vi place_old;
vi place_new;
long long dp[maxN][3];

long long f(int n, int y, vi& place) {
    if (n == 0) return 0;
    if (place[n] == y)
        return f(n - 1, y, place);
    int x = place[n];
    pii c = {x, y};
    if (c == pii{1, 2}) {
        return (f(n - 1, 3, place) + 1 + dp[n - 1][1]) % mod;
    }
    if (c == pii{2, 3}) {
        return (f(n - 1, 1, place) + 1 + dp[n - 1][2]) % mod;
    }
    if (c == pii{1, 3}) {
        return (f(n - 1, 3, place) + 1 + min(2 * dp[n - 1][2] + 1, dp[n - 1][1] + dp[n][1])) % mod;
    } 
    if (c == pii{3, 1}) {
        return (f(n - 1, 1, place) + 1 + min(2 * dp[n - 1][2] + 1, dp[n - 1][1] + dp[n][1])) % mod;
    }
    if (c == pii{2, 1}) {
        return (f(n - 1, 3, place) + 1 + dp[n - 1][2]) % mod;
    }
    if (c == pii{3, 2}) {
        return (f(n - 1, 1, place) + 1 + dp[n - 1][1]) % mod;
    }
}
int np;
int get(int n, vi& place_old, vi&place_new) {

    vi& place = place_old;
    pii c = {place_old[n], place_new[n]};
    int ans = 0;
    if (c == pii{1, 2}) {
        ans =  (f(n - 1, 3, place) + 1 + dp[n - 1][1]) % mod;
        np = 3;
    }
    if (c == pii{2, 3}) {
        ans =  (f(n - 1, 1, place) + 1 + dp[n - 1][2]) % mod;
        np = 1;
    }
    if (c == pii{1, 3}) {
        ans =  (f(n - 1, 3, place) + 1 + min(dp[n - 1][2] + 1, dp[n - 1][1] + dp[n][1])) % mod;
        np = 1;
    } 
    if (c == pii{3, 1}) {
        ans =  (f(n - 1, 1, place) + 1 + min(dp[n - 1][2] + 1, dp[n - 1][1] + dp[n][1])) % mod;
        np = 3;
    }
    if (c == pii{2, 1}) {
        ans =  (f(n - 1, 3, place) + 1 + dp[n - 1][2]) % mod;
        np = 3;
    }
    if (c == pii{3, 2}) {
        ans = (f(n - 1, 1, place) + 1 + dp[n - 1][1]) % mod;
        np = 1;
    }
    // cout << "return " << ans << endl;
    return ans;
}
void solve(){
    int n;
    cin >> n;
    place_old.resize(n + 1);
    place_new.resize(n + 1);
    for (int i = 1; i <= n; i++) cin >> place_old[i];
    for (int i = 1; i <= n; i++) cin >> place_new[i];
    
    int cur = n;    
    while(cur > 0 && place_old[cur] == place_new[cur]) cur--;
    if (cur == 0) {
        cout << 0; return;
    }
    // cout << "call get old -> new, new -> old" << endl;
    int ans = get(cur, place_old, place_new);
    cur--;
    vi a(cur + 1, np);
    ans += get(cur, place_new, a);
    // cout << "for test ans = ";
    cout << ans % mod;
    // cout << endl;
}
signed main(){
    #ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    #endif

    dp[1][1] = 1;
    dp[1][2] = 2;
    for (int i = 2; i < maxN; i++) {
        dp[i][1] = dp[i - 1][2] + 1 + dp[i - 1][1];
        dp[i][2] = min(3 * dp[i - 1][2] + 2, dp[i - 1][2] + 1 + dp[i - 1][1] + dp[i][1]);
        dp[i][1] %= mod;
        dp[i][2] %= mod;
    }
    // cout << "dp: " << endl;
    // for (int i = 0; i < 10; i++) {
    //     cout << dp[i][1] << " " << dp[i][2] << endl; 
    // }
    // cout << "==================" << endl;
    #ifdef LOCAL
    freopen("in2", "r", stdin);
    // freopen("out.txt", "w", stdout);
    #endif 
    int t = 1;
    cin >> t;
    while(t--){
        solve();
        cout << "\n";
    }
}