#include <bits/stdc++.h>
using namespace std;

#define endl '\n'
#define ll long long
#define pb push_back

const int timeStart = 8 * 60;
const int threshold = 10;

int parseTime(const string &s) {
    int hours = 0;
    int minutes = 0;
    bool mode = 0;
    for (char c : s) {
        if (c == ':') {
            mode = 1;
            continue;
        }
        if (!mode) hours = hours * 10 + (c-'0');
        else minutes = minutes * 10 + (c-'0');
    }

    return hours * 60 + minutes;
}

int solve(const vector<int> &times) {
    int n = times.size();
    for (int i = 0; i+2 < n; ++i) {
        if (times[i+2] - times[i] <= threshold) {
            return 0;
        }
    }
    for (int i = 0; i+1 < n; ++i) {
        if (times[i+1] - times[i] <= threshold) {
            return 1;
        }
    }
    return 2;
}

int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    #ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output1.txt", "w", stdout);
    #endif // LOCAL
    int n;
    cin >> n;
    string time;
    vector<int> times;
    for (int i = 0; i < n; ++i) {
        cin >> time;
        times.pb(parseTime(time));
    }
    sort(times.begin(), times.end());
    cout << solve(times) << endl;
    return 0;
}
