#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

using namespace std;
using ll = long long;

void solve();

int main() {
	ll t; cin >> t;
	while(t--)
	solve();

	return 0;
}

ll inf = 1e18;
ll MOD = 998244353;


ll bin_pow_mod(ll a, ll n)
{
	ll res = 1;
	while (n)
	{
		if (n & 1)
		{
			res *= a;
			res %= MOD;
		}

		n >>= 1;
		a *= a;
		a %= MOD;
	}

	return res;
}

void solve()
{
	ll n; cin >> n;
	vector<ll> a(n);
	vector<ll> b(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	for (int i = 0; i < n; i++) {
		cin >> b[i];
	}
	ll pos_a = 0;
	ll pos_b = 0;
	bool inva = false;
	bool invb = false;
	ll ge = 0;
	for (int i = n - 1; i >= 0; --i) {
		if (inva) {
			a[i] = 4 - a[i];
		}
		if (a[i] == 1) {
		}
		else if (a[i] == 3) {
			pos_a += 2 * bin_pow_mod(3, i);
		}
		else {
			pos_a += 1 * bin_pow_mod(3, i);
			inva = !inva;
		}
		if (invb) {
			b[i] = 4 - b[i];
		}
		if (b[i] == 1) {
		}
		else if (b[i] == 3) {
			pos_b += 2 * bin_pow_mod(3, i);
		}
		else {
			pos_b += 1 * bin_pow_mod(3, i);
			invb = !invb;
		}
		if (ge == 0) {
			if (a[i] > b[i]) {
				ge = 1;
			}
			else {
				ge = -1;
			}
		}
		pos_a %= MOD;
		pos_b %= MOD;
	}

	cout << (((ge * (pos_a - pos_b)) + MOD) % MOD) << endl;
}

