#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
typedef vector<ll> vi;

#define pb push_back
#define forn(i, n) for(ll i = 0; i < (n); ++i)
#define all(a) (a).begin(), (a).end()

void solve(){
    int n;
    cin >> n;

    vector<ll> a(n);
    forn(i, n) {
        cin >> a[i];
    }

    if (n == 2) {
        if (abs(a[0] - a[1]) > min(a[0], a[1])) {
            cout << "0\n";
        } else {
            cout << min(a[0], a[1]) - abs(a[0] - a[1]) << "\n";
        }
        return;
    }

    // diff[i] = a[i] - a[i - 1]
    vector<ll> diff(n);
    set<pair<ll, ll>, greater<pair<ll, ll>>> q;
    forn(i, n) {
        diff[i] = a[i] - a[(i + n - 1) % n];
        q.insert({diff[i], i});
    }


    auto get = [&](int i) {
        return pair<ll, ll>(diff[(i + n) % n], (i + n) % n);
    };

    // apply -1 -1 2
    vector<ll> op(n);
    while (q.begin()->first != 0) {
        // for (auto it : diff) {
        //     cout << it << " ";
        // }
        // cout << endl;
        // cout << q.begin()->first << endl;
        
        auto [val, i] = *q.begin();
        auto cnt = val;
    
        q.erase(get(i - 1));
        q.erase(get(i));
        q.erase(get(i + 2));

        // applied to center 
        op[i] += cnt;
        
        diff[i] -= cnt;
        diff[(i + n - 1) % n] -= cnt;
        diff[(i + n + 2) % n] -= 2 * cnt;

        q.insert(get(i - 1));
        q.insert(get(i));
        q.insert(get(i + 1));
    }

    auto top = *min_element(all(op));
    forn(i, n) {
        op[i] -= top;
    }

    auto sub = op[0] * 2 + op[1];
    cout << max(0LL, a[0] - sub) << "\n";    
}

int main(){
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(false);
    int t = 1;
    cin >> t;
    while (t--)
    {
        solve();
    }
}