#include <bits/stdc++.h>
// #pragma comment(linker, "/STACK:16777216")
// #pragma GCC optimize("O3,unroll-loops")
// #pragma GCC target("avx2,sse4,fma,bmi,bmi2,popcnt,lzcnt,abm,tune=native")

using namespace std;
using uint = unsigned int;
using ll = long long;
using ull = unsigned long long;
using dbl = double;
using ld = long double;
using pi = pair<int, int>;
using pll = pair<ll, ll>;
using pd = pair<dbl, dbl>;
using pld = pair<ld, ld>;

// #include <ext/pb_ds/assoc_container.hpp>
// #include <ext/pb_ds/tree_policy.hpp>
// using namespace __gnu_pbds;
// typedef tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

#define ft first
#define sc second
#define pb push_back
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

void solve() {
    int n, e;
    cin >> n >> e;
    vector<string> v(n);
    for (auto &i : v) cin >> i;
    vector<vector<int>> cnt(e, vector<int> (n, 0));
    vector<bool> bad(e, false);
    for (int i = 0; i < e; i++) {
        for (int j = 0; j < n; j++) {
            bool fl = true;
            for (char ps : v[j]) {
                if (ps != i + 'a') fl = false;
            }
            bad[i] = bad[i] | fl;
        }
    }
    int count = 0;
    for (int i = 0; i < e; i++) count += (int)(bad[i]);
    if (count == e) {
        cout << "NO";
        return;
    }
    vector<int> sm(e, 0);
    for (int symbol = 0; symbol < e; symbol++) {
        if (bad[symbol]) continue;
        for (int ps = 0; ps < n; ps++) {
            for (int i = 0; i < v[ps].size(); i++) {
                if (v[ps][i] != symbol + 'a') {
                    cnt[symbol][ps] = i;
                    break;
                }
            }
            sm[symbol] += cnt[symbol][ps];
        }
    }
    int ans = INT_MAX;
    for (int i = 0; i < e; i++) {
        if (bad[i]) continue;
        ans = min(ans, sm[i]);
    }
    for (int i = 0; i < e; i++) {
        if (bad[i]) continue;
        if (ans == sm[i]) {
            for (int j = 0; j < n; j++) {
                for (int ps = 0; ps < cnt[i][j]; ps++) {
                    cout << v[j][ps];
                }
            }
            cout << (char)(i + 'a');
            return;
        }
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    // freopen("", "r", stdin);
    // freopen("", "w", stdout);

    int t = 1;
    // cin >> t;
    while (t--) solve();
    return 0;
}