#include <bits/stdc++.h>

using namespace std;

int main()
{
    cin.tie(0);
    std::ios::sync_with_stdio(0);

    int t;
    cin >> t;
    while (t--)
    {
        int n;
        cin >> n;
        vector<long long> h(n), p(n);
        for (int i = 0; i < n; i++)
            cin >> h[i];
        for (int i = 0 ; i < n; i++)
            cin >> p[i];

        using pii = pair<int ,int>;
        vector<pii> vec(n);
        for (int i = 0; i < n; i++)
            vec[i] = {p[i], h[i]};
        sort(vec.begin(), vec.end());

        bool can = 1;
        for (int i = 0; i < n-1; i++)
            if (vec[i].second > vec[i+1].second)
                can = 0;

        using pii = pair<int, int>;
        multimap<int, int> mapa;
        for (int i = 0; i < n; i++)
            mapa.insert({p[i], i});

        long long res = 0;
        while (mapa.size())
        {
            auto [_, i] = *mapa.begin();
            mapa.erase(mapa.begin());

            long long delta = p[i] - h[i] - res;
            if (delta < 0ll)
                can = 0;

            res += delta;
        }

        if (can)
            cout << res << '\n';
        else
            cout << "-1\n";
    }
}