#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using pi = pair<ll,ll>;

ll mod = 998244353, k;

ll BP(ll a, ll n) {
    ll y = 1;
    while (n) {
        if (n % 2) y = y * a % mod;
        n /= 2;
        a = a * a % mod;
    }
    return y;
}

ll f2(ll n) {
    ll q = BP((k-1)*(k-1) %  mod, mod - 2);
    return k * BP(k-1, n) % mod * (BP(q, (n + 1) / 2) - 1 + mod) % mod * BP(q - 1 + mod, mod - 2) % mod;
}

ll f(ll n) {
    return (f2(n-1) - f2(n-2) + mod) % mod;
}

map <int,int> fenv;

void DB(ll l, ll x) {
    for (; l < 2e9; l += l & -l) fenv[l] += x;
}

ll S(ll l) {
    ll s = 0;
    for (; l > 0; l -= l & -l) s += fenv[l];
    return s;
}

ll SUM(ll l, ll r) {
    return S(r) - S(l-1);
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    ll t, q, i, n, m, l, r, anse;
    cin >> t;
    for (q = 0; q < t; q++) {
        cin >> n >> m >> k;
        vector <pair<ll,ll>> v(m);
        anse = 1;
        for (i = 0;  i < m; i++) {
            cin >> v[i].first >> v[i].second;
            if (v[i].first > v[i].second) swap(v[i].first, v[i].second);
        }
        sort(v.begin(), v.end());
        ll a = 0;
        if (k == 2) {
            for (i = 0; i < m; i++) {
                if ((v[i].second - v[i].first) % 2) a = 1;
            }
            if (a == 1 || n % 2) cout << "0\n";
            else cout << "2\n";
        } else if (m == 0) {
            cout << f(n) << '\n';
        } else {
            vector <ll> ans;
            vector <pi> st = {v[0]}, pp;

            for (i = 1; i < m; i++) {

                while (st.size() && v[i].second > st.back().second) {
                    pp.push_back(st.back());
                    st.pop_back();
                }
                st.push_back(v[i]);
            }
            while (st.size()) {
                pp.push_back(st.back());
                st.pop_back();
            }
            fenv.clear();
            for (i = 0; i < m; i++) {
                ans.push_back(pp[i].second - pp[i].first + 1 - SUM(pp[i].first, pp[i].second-1));
                DB(pp[i].first, ans.back() - 2);
            }
            ans.push_back(n - (pp.back().second - pp.back().first) + 1 - SUM(pp.back().second, n) - SUM(1, pp.back().first - 1));
            for (ll y : ans) anse = anse * f(y) % mod;
            cout << anse * BP(BP(k * (k - 1) % mod, mod - 2), ans.size() - 1) % mod << '\n';
        }
    }
}
