#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
using ull = unsigned long long;

const ll maxn = ll(2e5)+5;
const ll mod = 988244353;

ll binpow(ll n, ll a) {
    if (a == 0) return 1;
    if (a%2) return n*binpow(n, a-1)%mod;
    ll t = binpow(n, a/2);
    return t*t%mod;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i=0;i<n;++i) {
        char q;
        cin >> q;
        a[i] = (q-'0')*60;
        cin >> q;
        cin >> q;
        a[i] += (q-'0')*10;
        cin >> q;
        a[i] += (q-'0');
    }
    deque<ll> cur;
    ll ans=3;
    for (int i=0;i<n;++i) {
        cur.push_back(a[i]);
        while (cur.back() - cur[0] > 10) cur.pop_front();
        ans = min(3-(ll)cur.size(), ans);
    }
    cout << max(0LL, ans) << '\n';
    return 0;
}