#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
using ull = unsigned long long;

const ll maxn = ll(2e5)+5;
const ll mod = 988244353;

ll binpow(ll n, ll a) {
    if (a == 0) return 1;
    if (a%2) return n*binpow(n, a-1)%mod;
    ll t = binpow(n, a/2);
    return t*t%mod;
}

void solve() {
    ll n;
    cin >> n;
    vector<pair<ll, ll>> s(n);
    for (int i=0;i<n;++i) cin >> s[i].first;
    for (int i=0;i<n;++i) cin >> s[i].second;
    for (int i=0;i<n;++i) {
        s[i].second = s[i].second - s[i].first;
    }
    sort(s.begin(), s.end());
    for (int i=1;i<n;++i) {
        if (s[i].second < s[i-1].second) {
            cout << -1 << '\n';
            return;
        }
    }
    cout << s[n-1].second << '\n';
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    ll t;
    cin >> t;
    while(t--)solve();
    return 0;
}