#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
using ull = unsigned long long;

const ll maxn = ll(2e5)+5;
const ll mod = 988244353;

ll binpow(ll n, ll a) {
    if (a == 0) return 1;
    if (a%2) return n*binpow(n, a-1)%mod;
    ll t = binpow(n, a/2);
    return t*t%mod;
}

vector<ll> g[maxn];
bool used[maxn];
ll mrk[maxn];
ll cnt = 0, tt=0;
vector<ll> dd;
vector<pair<ll, ll>> rb;

void dfs(ll v) {
    used[v]=1;
    dd.push_back(v);
    mrk[v]=tt++;
    for (auto u: g[v]) {
        if (!used[u]) dfs(u);
    }
}

void solve() {
    ll n,m;
    cin >> n >> m;
    for (int i=0;i<n;++i) {
        g[i].clear();
        used[i]=0;
    }
    rb.clear();
    dd.clear();
    cnt = 0;
    tt=0;
    for (int i=0;i<m;++i) {
        ll v,u;
        cin >> v >> u;
        v--;u--;
        g[v].push_back(u);
        rb.push_back({v,u});
    }
    dfs(0);
    for (int i=0;i<m;++i) {
        if (mrk[rb[i].first] < mrk[rb[i].second])cnt++;
    }
    if (cnt >= (m+1)/2) {
        for (auto e: dd) cout << e+1 << ' ';
        cout << '\n';
    }
    else {
        cout << -1 << '\n';
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    ll t;
    cin >> t;
    while(t--)solve();
    return 0;
}