#include <algorithm>
#include <cassert>
#include <iostream>
#include <vector>
#include <set>
#include <string>
#include <map>
#include <deque>
using namespace std;
using ll = long long;


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, e;
    cin >> n >> e;
    vector<vector<int>> xd;
    for (int i = 0; i < n; i++) {
        string h;
        cin >> h;
        vector<int> st;
        for (auto &d: h) {
            st.push_back(d - 'a');
        }
        xd.push_back(st);
    }
    vector<bool> has(e, false);
    int cnt = 0;
    for (int i = 0; i < e; i++) {
        bool fl = false;
        for (int j = 0; j < n; j++) {
            if (count(xd[j].begin(), xd[j].end(), i) == xd[j].size()) {
                fl = true;
            }
        }
        has[i] = fl;
        cnt += fl;
    }
    if (cnt == e) {
        cout << "NO\n";
        return 0;
    }
    int mx = 1e9;
    int where = -1;
    for (int i = 0; i < e; i++) {
        if (has[i]) continue;
        int sst = 0;
        for (int j = 0; j < n; j++) {
            if (xd[j][0] != i) continue;
            int pt = 0;
            while (pt < xd[j].size() && xd[j][pt] == i) {
                pt++;
            }
            sst += pt;
        }
        if (mx > sst) {
            mx = sst;
            where = i;
        }
    }
    cout << string( mx + 1, ('a' + where));
}