import kotlin.math.max

fun cast(strings: String): Int {
    val (h, m) = strings.split(":").map { it.toInt() }
    val t = (h-7)*60 + m
    return t
}

fun main() {
    val (n) = readln().split(" ").map { it.toInt() }
    val alarms = (1..n).map { cast(readln()) }
    var mx = 1
    var l = 0
    var r = 0
    while (r != n-1) {
        r++
        while (alarms[r] - alarms[l] > 10) l++
        mx = max(mx, r-l+1)
    }
    if (mx >= 3)
        println(0)
    else
        println(3-mx)
}
