#include <bits/stdc++.h>

using namespace std;

using ll = long long;

int k;

int step0(int p) {
    if (p & (1 << k)) {
        p -= (1 << k);
    }
    return p << 1;
}

int step1(int p) {
    return step0(p) + 1;
}

const ll mod = 988244353;


bool cmp(pair<int, int> a, pair<int, int> b){
    if (a.first == b.first) return a.second < b.second;
    return a.first < b.first;
}

void solve(){
    int n;
    cin >> n;
    vector<int> h(n), p(n), r(n);
    for (int i = 0; i < n; ++i) cin >> h[i];
    for (int i = 0; i < n; ++i) cin >> p[i];
    int ma = -1;
    for (int i = 0; i < n; ++i) {
        r[i] = p[i] - h[i];
        ma = max(ma, r[i]);
        if (r[i] < 0) {
            cout << "-1\n";
            return;
        }
    }
    vector<pair<int, int>> pairs(n), pairs2(n);
    for (int i = 0; i < n; ++i) pairs[i] = {p[i], r[i]}, pairs2[i] = {p[i], h[i]};
    std::sort(pairs.begin(), pairs.end(), cmp);
    std::sort(pairs2.begin(), pairs2.end(), cmp);
    bool can = true;
    for (int i = 0; i < n - 1; ++i){
        if (pairs[i].second <= pairs[i + 1].second && pairs2[i].second <= pairs2[i + 1].second) continue;
        can = false;
    }
    if (!can) cout << "-1\n";
    else cout << ma << "\n";
}



int main() {
    int t;
    cin >> t;
    while (t--) solve();
}
