#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

#define all(vc) vc.begin(), vc.end()
#define full(vc) vc.begin(), vc.end()

#define fi first
#define fr first
#define se second
#define sc second

#define pb push_back

typedef vector<int> vi;
typedef vector<ll> vl;

const ll INF = 1e18;

template <typename T>
istream& operator>>(istream& in, vector<T> &vc)
{
    for (auto &el: vc) in >> el;
    return in;
}

void dfs(int v, vector <int> &used, vector <vector<pii>> &vc, vector <int> &tp, set <int> &mp)
{
    used[v] = 1;
    for (auto [u, i]: vc[v])
    {
        if (mp.count(i))
        {
            continue;
        }
        if (!used[u])
        {
            dfs(u, used, vc, tp, mp);
        }
    }
    tp.pb(v);
}

void solve()
{
    int n, m;
    cin >> n >> m;
    vector <vector<int>> vc(n);

    for (int i = 0; i < m; i++)
    {
        int a, b;
        cin >> a >> b;
        a--; b--;
        vc[a].pb(b);
    }
    int cnt = 0;
    for (int el = 0; el < n; el++)
    {
        for (auto u: vc[el])
        {
            if (el < u)
            {
                cnt++;
            }
        }
    }
    if (cnt < m / 2 + m % 2)
    {
        for (int i = n; i >= 1; i--) cout << i << ' ';
        return;
    }
    for (int i = 1; i <= n; i++) cout << i << ' ';
}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int t = 1;
    cin >> t;
    while (t--)
    {
        solve();
        cout << '\n';
    }
    return 0;
}
