#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/priority_queue.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace std;
using namespace __gnu_pbds;
//namespace r = ranges;
//namespace v = views;

typedef unsigned int uint;
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

#ifdef LOCAL
//#include "debug.h"
#else
#define debug(...) 533
#endif

template <typename K, typename V, template <typename> typename Comp = less> using ordered_map = tree<K, V, Comp<K>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename T, template <typename> typename Comp = less> using ordered_set = ordered_map<T, null_type, Comp>;
mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
template<typename T> T random(T l, T r) { return uniform_int_distribution<T>(l, r)(rng); }

const int mod = 1'000'000'007;

void solve(istream &cin = std::cin, ostream &cout = std::cout) {
    int n;
    cin >> n;
    vector<int> h(n), p(n);
    for (auto &i: h) cin >> i;
    for (auto &i: p) cin >> i;
    vector<pair<int, int>> q;
    for (int i = 0; i < n; i++) {
        q.emplace_back(p[i], p[i] - h[i]);
    }
    sort(q.rbegin(), q.rend());
    bool can = true;
    int now = numeric_limits<int>::max();
    for (int i = 0; i < n; i++) {
        if (q[i].second > now) can = false;
        if (q[i].second < 0) can = false;
        if (i != 0 && q[i].second - q[i - 1].second <= q[i].first - q[i - 1].first) can = false;
        now = q[i].second;
    }
    if (can) cout << q[0].second << '\n';
    else cout << -1 << '\n';
}
/*

*/
signed main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr);
    int test = 1;
#if LOCAL
    ifstream cin("../danya.in"); // ofstream cout("../danya.out");
    cin >> test;
    if (test == 0) cerr << "CHANGE .IN FILE" << endl;
    for (int i = 1; i <= test; i++) {
        const auto divider = string(30, '=');
        cout << divider << ' ' << i << ' ' << divider << '\n';
        solve(cin, cout);
        cout << '\n';
    }
#else
    // ifstream cin(".in"); ofstream cout(".out");
     cin >> test;
    for (int i = 0; i < test; i++) {
        solve(cin, cout);
    }
#endif
}