// ConsoleApplication1.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>
#include <vector>
#include <algorithm>
#include <utility>
#include <string>
#include <map>
using namespace std;

#define ll long long

int main()
{
	ll t, n;
	cin >> t;

	for (auto i = 0; i < t; ++i)
	{
		cin >> n;

		vector<ll> current_h(n);
		vector<ll> past_h(n);
		vector<char> curr_diffes(current_h.size() - 1);
		vector<char> past_diffes(past_h.size() - 1);
		multimap<ll, size_t> past_orders;

		for (size_t k = 0; k < n; ++k)
			cin >> current_h[k];

		for (size_t k = 0; k < n; ++k)
		{
			cin >> past_h[k];
			past_orders.insert({ past_h[k], k });
		}

		for (size_t k = 0; k < curr_diffes.size(); ++k)
			curr_diffes[k] = current_h[k] - current_h[k + 1] >= 0 ? '+' : '-';

		for (size_t k = 0; k < past_diffes.size(); ++k)
		{
			past_diffes[k] = past_h[k] - past_h[k + 1] >= 0 ? '+' : '-';

			if (curr_diffes[k] != past_diffes[k])
			{
				cout << -1;
				return 0;
			}
		}

		ll max_diff{-1};
		
		ll pred_diff{ 1000001 };

		for (auto iter = past_orders.rbegin(); iter != past_orders.rend(); ++iter)
		{
			ll diff = past_h[iter->second] - current_h[iter->second];

			if (diff > pred_diff)
			{
				max_diff = -1;
				break;
			}

			pred_diff = diff;

			if (diff < 0)
			{
				max_diff = -1;
				break;
			}

			max_diff = max(max_diff, diff);
		}

		//for (auto k = 0; k < n; ++k)
		//{
		//	ll diff = past_h[k] - current_h[k];

		//	if (diff < 0)
		//	{
		//		max_diff = -1;
		//		break;
		//	}

		//	max_diff = max(max_diff, diff);
		//}

		cout << max_diff << endl;
	}
}
