//
// Created by qf on 16.11.2024.
//
#include <bits/stdc++.h>
#define ll long long
#define ld long double
#define all(x) x.begin(),x.end()

using namespace std;

ll n, m;
vector<ll> c[100005], g[100005];
ll val[100005], ord[100005];
bool used[100005];

void solve() {
    cin >> n >> m;

    for (int i = 0; i <= n; i++) {
        c[i].clear();
        g[i].clear();
        val[i] = 0;
        ord[i] = 0;
        used[i] = false;
    }
    for (int i = 0; i < m; i++) {
        ll x, y;
        cin >> x >> y;
        c[x].push_back(y);
        g[y].push_back(x);
    }
    set<pair<ll, ll>> q;
    for (int i = 1; i <= n; i++) {
        val[i] = (ll)c[i].size() - (ll)g[i].size();
        q.insert({-val[i], i});
    }
    ll ans = 0, j = 0;
    while (!q.empty()) {
        auto [v, h] = *q.begin();
        q.erase(q.begin());
        used[h] = true;
        ans -= v;
        ord[h] = ++j;
        for (int i = 0; i < c[h].size(); i++) {
            auto to = c[h][i];
            if (!used[to]) {
                q.erase({-val[to], to});
                val[to]++;
                q.insert({-val[to], to});
            }
        }
        for (int i = 0; i < g[h].size(); i++) {
            auto to = g[h][i];
            if (!used[to]) {
                q.erase({-val[to], to});
                val[to]--;
                q.insert({-val[to], to});
            }
        }
    }
    if (ans < 0) {
        for (int i = 1; i <= n; i++) {
            ord[i] = n - ord[i] + 1;
        }
    }
    for (int i = 1; i <= n; i++) {
        cout << ord[i] << " ";
    }
    cout << endl;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    ll t;
    cin >> t;
    while (t--) {
        solve();
    }
}