#include<bits/stdc++.h>

// #define int long long
// #define f(i, n) for(int i = 0; i < (int)n; i++)
// #define F(i, a, b) for(int i = (int)a; i <= (int)b; i++)
#define ll long long
#define pii pair<int, int>
#define vii vector<pii>
#define ld long double
#define vi vector<int>
#define vll vector<ll>
#define pb push_back
#define all(x) x.begin(), x.end()
const int maxN = 2e5 + 5;
const int inf = 2e9;
const ld pi = acosl(-1);
const ld eps = 1e-5;
const int mod = 1e9 + 7;

using namespace std;
vi cntp;
vi cntm;
int was[maxN];
bool cmp(int l, int r) {
    return cntp[l] - cntm[l] < cntp[r] - cntm[r];
}
vi topsort;
void dfs(int v, vector<vector<int>>& g) {
    was[v] = 1;
    for(auto to : g[v]) {
        if (was[to] == 0) dfs(to, g);
    }
    topsort.pb(v);
}

vector<int> solve2(vector<pii>& edges, int n, int m) {
    // исх - вход, всё по убыванию
    set<vector<int>> s;
    vector<vector<int>> g(n + 1, vector<int>());
    cntp.resize(n + 1, 0);
    cntm.resize(n + 1, 0);
    for (int& x : cntp) x = 0;
    for (int& x : cntm) x = 0;

    for (auto [a, b] : edges) {
        g[a].pb(b);
        cntp[a]++; // исход
        cntm[b]++; // вход
    }

    vi ans;
    vi was(n + 1, 0);
    for (int i = 1; i <= n; i++) {
        s.insert({-(cntp[i] - cntm[i]), -cntp[i], i});
    }
    while(s.size() > 0) {
        auto x = *(s.begin()); s.erase(x);
        was[x[2]] = 1;
        // cout << "now x[2] = " << x[2] << endl;
        ans.push_back(x[2]);
        int v = x[2];
        for (auto to : g[v]) {
            if (was[to] == 1) continue;
            vector<int> was(3);
            vector<int> cur = {-(cntp[to] - cntm[to]), -cntp[to], to};
            s.erase(s.find(cur));
            cntm[to]--;
            cur = {-(cntp[to] - cntm[to]), -cntp[to], to};
            s.insert(cur);
        }
    }
    // cout << "ans = "; for (auto x : ans) cout << x << " ";
    // cout << endl;

    vi order(n + 1, 0);
    for (int i = 0; i < ans.size(); i++) {
        order[ans[i]] = i + 1;
    }

    int k = 0;

    for (auto [a, b] : edges) {
        if (order[a] < order[b]) k++;
    }

    if (k >= (m + 1) / 2) {
        return ans;
    } else {
        return vi{};
    }

}

vector<int> solve(vector<pii>& edges, int n, int m){
    vector<vector<int>> g(n + 1, vector<int>());
    cntp.resize(n + 1, 0);
    cntm.resize(n + 1, 0);
    for (int& x : cntp) x = 0;
    for (int& x : cntm) x = 0;
    for (auto [a, b] : edges) {
        g[a].pb(b);
        cntp[a]++;
        cntm[b]++;
    }
    for (int i = 1; i <= n; i++) {
        sort(all(g[i]), cmp);
    }
    fill(was, was + n + 2, 0);
    topsort.clear();
    for (int i = 1; i <= n; i++) {
        if (was[i] == 0) {
            dfs(i, g);
        }
    }
    reverse(all(topsort));
    vi order(n + 1, 0);
    for (int i = 0; i < topsort.size(); i++) {
        order[topsort[i]] = i + 1;
    }

    int k = 0;

    for (auto [a, b] : edges) {
        if (order[a] < order[b]) k++;
    }

    if (k >= (m + 1) / 2) {
        return topsort;
    } else {
        return vi{};
    }
}
signed main(){
    #ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    #endif

    #ifdef LOCAL
    freopen("in", "r", stdin);
    // freopen("out.txt", "w", stdout);
    #endif 
    int t = 1;
    cin >> t;
    while(t--){
        int n,m;
        vector<pii> edges;
        cin >> n >> m;
        for (int i = 0; i < m; i++) {
            int a,b;
            cin >> a >> b;
            edges.pb({a, b});

        }
        vi ans = solve2(edges, n, m);
        if (ans.size() != 0) {
            for(auto x : ans) cout << x << " ";
            cout << "\n"; 
            continue;
        }    
        ans = solve(edges, n, m);
        if (ans.size() != 0) {
            for (auto x : ans) cout << x << " ";
            cout << "\n";
            continue;
        }   
        cout << -1 << "\n";
    }
}