#include <bits/stdc++.h>

using namespace std;
const int p=998244353;
int po(int a,int b) {if(b==0) return 1; if(b==1) return a; if(b%2==0) {int u=po(a,b/2);return (u*1LL*u)%p;} else {int u=po(a,b-1);return (a*1LL*u)%p;}}
int inv(int x) {return po(x,p-2);}
mt19937 rnd;


#define app push_back
#define all(x) (x).begin(),(x).end()
#ifdef LOCAL
#define debug(...) [](auto...a){ ((cout << a << ' '), ...) << endl;}(#__VA_ARGS__, ":", __VA_ARGS__)
#define debugv(v) do {cout<< #v <<" : {"; for(int izxc=0;izxc<v.size();++izxc) {cout << v[izxc];if(izxc+1!=v.size()) cout << ","; }cout <<"}"<< endl;} while(0)
#else
#define debug(...)
#define debugv(v)
#endif
#define lob(a,x) lower_bound(all(a),x)
#define upb(a,x) upper_bound(all(a),x)

const int N = 1e6+7;

int par[N], cnt[N], alive[N];
int root(int u) {
    if (par[u]==u) {
        return u;
    }
    else {
        return par[u] = root(par[u]);
    }
}
void merge(int u, int v) {
    u = root(u); v = root(v);
    if (cnt[v] < cnt[u]) {
        swap(u,v);
    }
    par[u]=v;
    cnt[v]+=cnt[u];
}



///dcp offline
struct Dsu {
  int n;
  vector<pair<int &, int>> s;
  vector<int> p, sz;
  // other info

  Dsu(int n) : n(n), p(n), sz(n, 1){
    iota(all(p), 0);
  }

  int get(int u) {
    while (u != p[u]) u = p[u];
    return u;
  }

  bool merge(int u, int v) {
    u = get(u), v = get(v);
    if (u == v) return false;
    if (sz[v] < sz[u]) swap(u, v);
    s.app({p[u], p[u]});
    s.app({sz[v], sz[v]});
    // app other info like s.app({comp, comp});
    p[u] = v;
    sz[v] += sz[u];
    return true;
  }

  void rollback(int sz) {
    while (s.size() != sz) {
      s.back().first = s.back().second;
      s.pop_back();
    }
  }
};

struct DcpOffline {
  int n;
  vector<vector<pair<int, int>>> d;

  void addEdgeOnSegment(int l, int r, int a, int b, bool print) {
      if (print&&l<r) {
        debug(l,r,a,b);
      }
    for (l += n, r += n; l < r; l /= 2, r /= 2) {
      if (l & 1) d[l++].app({a, b});
      if (r & 1) d[--r].app({a, b});
    }
  }


  bool dfs(int size, int s, int f) {
    Dsu dsu(size);
    return dfs(1, 0, n, dsu, s, f);
  }


  bool dfs(int v, int l, int r, Dsu &dsu, int s, int f) {
    int sz = dsu.s.size();
    for (auto [u, v]: d[v]) {
      dsu.merge(u, v);
    }
    bool res = true;
    if (l + 1 == r) {
      if (dsu.get(s) != dsu.get(f)) res = false;
    } else {
      int m = (l + r) / 2;
      res = dfs(v * 2, l, m, dsu, s,f);
      if (res) res &= dfs(v * 2 + 1, m, r, dsu, s,f);
    }
    dsu.rollback(sz);
    return res;
  }

  DcpOffline(int maxt) : n(2 << __lg(maxt + 1)), d(2 * n) {}
};




int32_t main()
{
    ios_base::sync_with_stdio(false);cin.tie(0);cout.tie(0);
    auto solve1 = [&] (int n, int m, vector <string> &a, int &ans) {
        vector <vector <int> > pre(n, vector <int> (m)), suf(n, vector <int> (m));

        auto clear = [&] () {
            for (int i = 0; i < n; ++i) {
                for (int j = 0; j < m; ++j) {
                    int u = i * m + j;
                    par[u] = u;
                    cnt[u] = 1;
                    alive[u] = 0;
                }
            }
        };

        clear();

        vector <pair <int, int > > v = { {-1, 0}, {1, 0}, {0, -1}, {0, 1} };
        auto on = [&] (int x, int y) {
            alive[x * m + y] = 1;
            for (auto [dx, dy] : v) {
                int nx = x + dx, ny = y + dy;
                if (0 <= nx && nx < n && 0 <= ny && ny < m && alive[nx * m + ny]) {
                    merge(x * m + y, nx * m + ny);
                }
            }
        };

        int S = -1, F = -1;
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < m; ++j) {
                if (a[i][j] == 's') {
                    S = i * m + j;
                }
                if (a[i][j] == 'f') {
                    F = i * m + j;
                }
            }
        }

        vector <int> pres(n, -1), pref(n, -1), sufs(n, -1), suff(n, -1);

        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < m; ++j) {
                if (a[i][j] != '#') {
                    on(i,j);
                }
            }
            for (int j = 0; j < m; ++j) {
                pre[i][j] = root(i * m + j);
            }
            if (S/m <= i) {
                pres[i] = root(S);
            }
            if (F/m <= i) {
                pref[i] = root(F);
            }
        }

        clear();
        for (int i = n - 1; i >= 0; --i) {
            for (int j = 0; j < m; ++j) {
                if (a[i][j] != '#') {
                    on(i,j);
                }
            }
            for (int j = 0; j < m; ++j) {
                suf[i][j] = root(i * m + j);
            }
            if (S/m >= i) {
                sufs[i] = root(S);
            }
            if (F/m >= i) {
                suff[i] = root(F);
            }
        }

        vector <vector <int> > go(n, vector <int> (m)), gl(n, vector <int> (m));
        for (int i = 0; i < n; ++i) {
            for (int j = m - 1; j >= 0; --j) {
                if (j + 1 == m || a[i][j + 1] != '.') {
                    go[i][j] = j + 1;
                }
                else {
                    go[i][j] = go[i][j + 1];
                }
            }
            for (int j = 0; j < m; ++j) {
                if (a[i][j] != '.') {
                    gl[i][j] = j;
                }
                else if (j == 0) {
                    gl[i][j] = -1;
                }
                else {
                    gl[i][j] = gl[i][j - 1];
                }
            }
        }

        vector <int> c;
        auto sj = [&] (vector <int> &a, int &x, int &y, int add) {
            c = a;
            sort(all(c)); c.resize(unique(all(c)) - c.begin());
            for (int & e : a) {
                e = lower_bound(all(c), e) - c.begin();
                e += add;
            }
            if (x != -1) {
                    x = lower_bound(all(c), x) - c.begin();
                    x += add;
            }
            if (y != -1) {
                    y = lower_bound(all(c), y) - c.begin();
                    y += add;
            }
        };


        for (int i = 0; i < n; ++i) {
                debugv(pre[i]);
        debug(i, pres[i], pref[i], n, m);
            sj(pre[i], pres[i], pref[i], m);

            sj(suf[i], sufs[i], suff[i], 2 * m);

        }



        auto check = [&] (int i, int k) {
            bool print = i == 1 && k == 1;
            DcpOffline d(m);
            for (int j = 0; j < m; ++j) {
                if (a[i][j] == '#') {
                    continue;
                }
                if (i) {
                    int v = pre[i - 1][j];
                    d.addEdgeOnSegment(0, max(gl[i][j], j - k) + 1, j, v, print);
                    d.addEdgeOnSegment(j + 1, d.n, j, v, print);


                }
                if (i + 1 < n) {
                    int v = suf[i + 1][j];
                    d.addEdgeOnSegment(0, max(gl[i][j], j - k) + 1, j, v, print);
                    d.addEdgeOnSegment(j + 1, d.n, j, v, print);
                }

                if (j + 1 < m && a[i][j] != '#' && a[i][j + 1] != '#') {
                    d.addEdgeOnSegment(0, max(gl[i][j], j - k) + 1, j, j + 1, print);
                    d.addEdgeOnSegment(j + 2, d.n, j, j + 1, print);
                    d.addEdgeOnSegment(j + 2, max(gl[i][j], j - k) + 1, j, j + 1, print);
                    d.addEdgeOnSegment(j + 1, max(gl[i][j + 1], j + 1 - k) + 1, j, j + 1, print);
                }
            }

            int s1 = -1, f1 = -1;

            if (i && pres[i - 1] != -1) {
                s1 = pres[i - 1];
            }

            if (i && pref[i - 1] != -1) {
                f1 = pref[i - 1];
            }

            if (i + 1 < n && sufs[i + 1] != -1) {
                s1 = sufs[i + 1];
            }

            if (i + 1 < n && suff[i + 1] != -1) {
                f1 = suff[i + 1];
            }

            if (S/m==i) {
                s1 = S%m;
            }

            if (F/m==i) {
                f1 = F%m;
            }


            debug("check", i, k, d.dfs(3 * m, s1, f1));
            debug(s1,f1);
            return d.dfs(3 * m, s1, f1);
        };

        vector <int> ord(n);
        iota(all(ord), 0);
        shuffle(all(ord), rnd);
        for (int row : ord) {
            if (ans > 1 && !check(row, ans - 1)) {
                ans--;
                int lo = 0;
                while (lo < ans - 1) {
                    int mid = (lo + ans) / 2;
                    if (!check(row, mid)) {
                        ans = mid;
                    }
                    else {
                        lo = mid;
                    }
                }
            }
        }

    };
    auto solve = [&] () {
        int n, m;
        cin >> n >> m;
        vector <string> a(n);
        for (int i = 0; i < n; ++i) {
            cin >> a[i];
        }

        const int inf = 1e9;
        int ans = inf;
        solve1(n, m, a, ans);
        vector <string> b(m);
        for (int i = 0; i < m; ++i) {

            for (int j = 0; j < n; ++j) {
                b[i] += a[j][i];
            }
        }
        debug("tr");
        solve1(m,n, b, ans);
        if (ans == inf)
            cout << -1 << '\n';
        else
            cout << ans << '\n';
    };
    int t;
    cin >> t;
    while (t--) {
        solve();
    }

    return 0;
}

/*

1
2 3
s.f
...

*/
