#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;
using ll = long long;

void solve();

int main() {
	ll TT; cin >> TT;
	while (TT--)
	{
		solve();
	}
	return 0;
}

void solve()
{
	ll n; cin >> n;
	vector<ll> p(n), h(n), a(n);
	for (int i = 0; i < n; ++i)
	{
		cin >> h[i];
	}
	for (int i = 0; i < n; ++i)
	{
		cin >> p[i];
	}
	for (int i = 0; i < n; ++i)
	{
		a[i] = i;
	}
	sort(
		a.begin(), a.end(), [&](int i, int j) {return p[i] < p[j]; }
	);
	bool ok = true;
	for (int j = 1; j < n; ++j)
	{
		ll i = a[j];
		ll i_1 = a[j - 1];
		if (p[i] - h[i] < p[i_1] - h[i_1])
		{
			ok = false;
		}
		if (p[i] == p[i_1] && h[i] != h[i_1])
		{
			ok = false;
		}
		if (h[i] < h[i_1])
		{
			ok = false;
		}
	}
	for (int j = 0; j < n; ++j)
	{
		ll i = a[j];
		if (p[i] < h[i])
		{
			ok = false;
		}
	}
	if (!ok)
	{
		cout << -1 << endl;
		return;
	}
	cout << p[a[n - 1]] - h[a[n - 1]] << endl;

}

