#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

using namespace std;
using ll = long long;

void solve();

int main() {

	solve();

	return 0;
}

ll inf = 1e18;
ll mod = 998244353;

void solve()
{
	ll n, m, k; cin >> n >> m >> k;
	string s;
	ll K = 1 << (k + 1);
	cin >> s;
	if (n > m) {
		swap(n, m);
	}
	ll cur_num = 0;
	for (int i = 0; i < k; i++) {
		cur_num += (s[i] - '0') << (k - i - 1);
	}
	ll my_mask = 0;
	my_mask |= 1ll << cur_num;
	my_mask |= 1ll << (cur_num * 2);
	my_mask |= 1ll << (cur_num * 2 + 1);
	my_mask |= 1ll << (cur_num + K / 2);
	vector < vector<ll>> graph(K, vector<ll>());
	for (int i = 0; i < K; i++) {
		graph[i].push_back((i * 2) & (K - 1));
		graph[i].push_back(((i * 2) & (K - 1)) + 1);
	}
	vector<vector<ll>> dpprev(1LL << K, vector<ll>(K, 0));
	vector<vector<ll>> dpn(1LL << K, vector<ll>(K, 0));
	vector<vector<ll>> dpm(1LL << K, vector<ll>(K, 0));
	vector<vector<ll>> dpcur(1LL << K, vector<ll>(K, 0));
	for (int i = 0; i < K; i++) {
		dpprev[1 << i][i] = 1;
	}
	dpcur = dpprev;
	if (n == 1 + k) {
		dpn = dpcur;
	}
	if (m == 1 + k) {
		dpm = dpcur;
	}
	for (int i = 2; i < 101; i++) {
		for (int j = 0; j < (1 << K); j++) {
			for (int l = 0; l < K; l++) {
				dpcur[j][l] = 0;
			}
		}
		for (int j = 0; j < (1 << K); j++) {
			for (int l = 0; l < K; l++) {
				dpcur[j | (1 << graph[l][0])][graph[l][0]] += dpprev[j][l];
				dpcur[j | (1 << graph[l][1])][graph[l][1]] += dpprev[j][l];
				dpcur[j | (1 << graph[l][0])][graph[l][0]] %= mod;
				dpcur[j | (1 << graph[l][1])][graph[l][1]] %= mod;
			}
		}

		if (n == i + k) {
			dpn = dpcur;
		}
		if (m == i + k) {
			dpm = dpcur;
		}
		swap(dpprev, dpcur);
	}
	vector<ll> xdpm(1LL << K, 0);
	vector<ll> xdpn(1LL << K, 0);

	for (int l = 0; l < K; l++) {
		for (int j = 0; j < (1 << K); j++) {
			xdpm[j] += dpm[j][l];
			xdpn[j] += dpn[j][l];
		}
	}
	vector<ll> tsardpm(1LL << K, 0);

	for (int mask = 0; mask < (1 << K); mask++) {
		ll submask = mask;
		while (submask > 0) {
			if (submask & my_mask)
				tsardpm[mask] = (tsardpm[mask] + xdpm[submask]) % mod;
			submask--;
			submask &= mask;
		}
	}

	ll ans = 0;
	for (int mask = 0; mask < (1 << K); mask++) {
		if (mask & my_mask) {
			ans += xdpn[mask] * tsardpm[mask ^ ((1 << K) - 1)];
			ans %= mod;
		}
	}
	if (n == k && m == k) {
		cout << 1 << endl;
		return;
	}
	if (n == k) {
		cout << tsardpm[(1LL << K) - 1];
		return;
	}
	cout << ans << endl;
}

