#include <bits/stdc++.h>

using namespace std;

bool check(int X, vector<int> a) {
    for (int& x : a) {
        x -= X;
        if (x < 0) return false;
    }
    bool good = true;
    while (good) {
        for (int i = 0; i < a.size(); ++i) {
            if (a[i] < 0) return false;
            if (a[i] % 2 == 1) {
                a[(i + 1) % a.size()] -= 2;
                a[i]--;
            }
        }
        if (a[0] < 0) return false;
        good = false;
        for (int& x : a) {
            x /= 2;
            good |= x != 0;
        }
    }
    return true;
}

void solve(vector<int>& a) {
    int n;
    cin >> n;
    a.resize(n);
    for (int& x : a) cin >> x;
    long long sum = 0;
    int mn = a[0];
    for (int x : a) {
        sum += x;
        mn = min(mn, x);
    }
    int ans = 0;
    for (int rem = 0; rem < 3; ++rem) {
        if ((sum - rem * n) % 3 != 0) continue;
        int L = 0;
        int R = mn / 3 + 1;
        while (R - L > 1) {
            int M = L + (R - L) / 2;
            if (check(3 * M + rem, a)) {
                L = M;
            } else {
                R = M;
            }
        }
        if (check(3 * L + rem, a)) ans = max(ans, 3 * L + rem);
    }
    cout << ans << '\n';
    a.clear();
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int t;
    cin >> t;
    vector<int> a;
    a.reserve(2e5 + 1);
    while (t--) {
        solve(a);
    }

    return 0;
}
