#include <bits/stdc++.h>
using namespace std;

struct ListNode {
    int value;
    ListNode* prev;
    ListNode* next;
};

void addNode(ListNode*& node, int value, bool insertNext) {
    //cout << "HAHA";
    ListNode* newNode = new ListNode;
    if (insertNext){
        newNode->value = value;
        newNode->next = nullptr;
        newNode->prev = node;
        node->next = newNode;
    } else {
        newNode->value = value;
        newNode->next = node;
        newNode->prev = nullptr;
        node->prev = newNode;
    }
    node = newNode;
}

void initMap(map<int, ListNode*>& m, int n){
    for (int i = 1; i <= n; i++)
        m[i] = nullptr;
}

int main() {
    int t;
    cin >> t;

    for (int k = 0; k < t; k++){
        int n, m;
        cin >> n >> m;
        vector<pair<int, int>> edge(m);
        map<int, ListNode*> addressNode;
        for (int i = 0; i < m; i++){
            cin >> edge[i].first >> edge[i].second;
        }

        initMap(addressNode, n);
        sort(edge.begin(), edge.end());

        ListNode* left = new ListNode;
        ListNode* right = new ListNode;
        left->value = edge[0].first;
        right->value = edge[0].second;
        left->next = right;
        left->prev = nullptr;
        right->prev = left;
        right->next = nullptr;
        addressNode[edge[0].first] = left;
        addressNode[edge[0].second] = right;

        for (int i = 1; i < m; i++){
            if (addressNode[edge[i].first] == nullptr){
                //cout << "AAAA";
                addNode(left, edge[i].first, false);
                addressNode[edge[i].first] = left;
                //cout << "AAAA12";
                if (addressNode[edge[i].second] == nullptr) {
                    addNode(right, edge[i].second, true);
                    addressNode[edge[i].first] = right;
                }
            } else {
                if (addressNode[edge[i].second] == nullptr) {
                    addNode(right, edge[i].second, true);
                    addressNode[edge[i].second] = right;
                }
            }
        }

        ListNode* nowNode = left;
        while(nowNode != nullptr){
            cout << nowNode->value << " ";
            nowNode = nowNode->next;
        }
        cout << endl;
        /*for (auto now : arr){
            cout << now.first << " " << now.second << endl;
2
3 3
1 2
2 3
3 1
5 6
4 2
2 1
4 3
1 4
3 2
3 5
        }*/
    }


    return 0;
}
