#include <bits/stdc++.h>

using namespace std;

#define int long long

void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> deg(n);

    for (int i = 0; i < m; i++) {
        int u, v;
        cin >> u >> v;
        u--, v--;
        deg[u]--;
        deg[v]++;
    }
    
    vector<int> a(n);
    iota(a.begin(), a.end(), 0);

    sort(a.begin(), a.end(), [&](int i, int j) {
        return deg[i] < deg[j];
    });

    for (int i = 0; i < n; i++) {
        cout << a[i] + 1 << " \n"[i + 1 == n];
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    #ifdef LOCAL
    freopen("input.txt", "r", stdin);
    #endif

    int cntTests = 1;
    cin >> cntTests;
    for (int i = 1; i <= cntTests; i++) {
        solve();
    }
}
