#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
using ull = unsigned long long;

const ll maxn = ll(2e5)+5;
const ll mod = 988244353;

ll binpow(ll n, ll a) {
    if (a == 0) return 1;
    if (a%2) return n*binpow(n, a-1)%mod;
    ll t = binpow(n, a/2);
    return t*t%mod;
}

ll ans[maxn];


void solve() {
    ll n,m;
    cin >> n >> m;
    vector<pair<ll,ll>> rb;
    for (int i=0;i<m;++i) {
        ll v,u;
        cin >> v >> u;
        v--;u--;
        rb.push_back({v,u});
    }
    while (true) {
        random_shuffle(ans, ans+n);
        ll cnt = 0;
        for (int i=0;i<m;++i) if (ans[rb[i].first] < ans[rb[i].second])cnt++;
        if (cnt >= (m+1)/2) {
            vector<pair<ll, ll>> vv;
            for (int i=0;i<n;++i) vv.push_back({ans[i], i});
            sort(vv.begin(), vv.end());
            for (int i=0;i<n;++i) cout << vv[i].second+1 << ' ';
            cout << '\n';
            return;
        }
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    ll t;
    cin >> t;
    for (int i=0;i<maxn;++i) ans[i] = i;
    while(t--)solve();
    return 0;
}