#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <cstdint>
#include <numeric>
#include <algorithm>

using namespace std;
typedef long long ll;
typedef unsigned long long ull;

void solve() {
    ll n, y{0};
    cin >> n;
    vector<ll> h (n), p(n), d(n), curr;
    vector<bool> avail (n, 1);
    vector<pair<ll, ll>> del;
    for (ll i = 0; i < n; ++i) {
        cin >> h[i];
    }
    for (ll i = 0; i < n; ++i) {
        cin >> p[i];
        d[i] = p[i] - h[i]; //TMP
    }
    
    while(1) {
        if (!accumulate(avail.begin(), avail.end(), 0)) break;
        ll _min = INT64_MAX;    
        for (ll i = 0; i < n; ++i) {
            if(!avail[i]) {continue;}
            if (h[i] == _min) {
                curr.push_back(i);
            }
            if (h[i] < _min) {
                curr.clear();
                curr.push_back(i);
                _min = h[i];
            }
        } // here curr contains indices of all min heights

        for(auto &x : curr) {
            ll d = p[x] - h[x];
            if (d) del.push_back({d, x});
            else avail[x] = 0;
        }
        if (del.empty()) continue; 
        sort (del.begin(), del.end());  
        int tmpH = h[del[0].second];
        for (int i = 0; i < n; ++i) {    
            if (del[0].second == i || h[i] > tmpH) h[i]++;
            if (h[i] > p[i]) {
                cout << -1;
                return;
            }
        }
        y++;
        del.clear();
    }
    cout << y << '\n';
}

int main() {
    ios_base::sync_with_stdio(false);

    int t;
    cin >> t;
    while (t--) {
        solve();
    }


    return 0;
}