#include <bits\\stdc++.h>
using namespace std;

void solve() {
    int n;
    cin >> n;
    vector<int> h(n), p(n);
    for (int i = 0; i < n; i++) cin >> h[i];
    for (int i = 0; i < n; i++) cin >> p[i];
    map<int, int> q;
    for (int i = 0; i < n; i++) {
        if (q.contains(p[i])) {
            if (q[p[i]] == h[i]) {
                continue;
            }
            cout << "-1\n";
            return;
        }
        q[p[i]] = h[i];
    }
    vector<pair<int, int>> hp;
    for (int i = 0; i < n; i++) {
        hp.emplace_back(p[i], h[i]);
    }
    ranges::sort(hp);
    for (int i = 0; i + 1 < n; i++) {
        if (hp[i + 1].second < hp[i].second) {
            cout << "-1\n";
            return;
        }
    }
    vector<pair<int, int>> mp;
    for (int i = 0; i < n; i++) {
        if (p[i] - h[i] < 0) {
            cout << "-1\n";
            return;
        }
        mp.emplace_back(p[i], p[i] - h[i]);
    }
    ranges::sort(mp);
    ranges::reverse(mp);
    for (int i = 0; i + 1 < n; i++) {
        if (mp[i].second < mp[i + 1].second) {
            cout << "-1\n";
            return;
        }
    }
    cout << mp[0].second << "\n";
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    for (int i = 0; i < t; i++)
        solve();
}
